/*
 *  GPService.h
 */

struct svcbase
{
    /* Die ersten vier Elemente sind aus der Struktur MyLibrary aus
     * libinit.c bernommen und mssen so am Anfang der Struktur stehen.
     */
    struct  Library ml_Lib;
    ULONG   ml_SegList;
    ULONG   ml_Flags;
    struct Library *ml_ExecBase;
    /* Nun die Elemente, die wir fr unseren Service hinzufgen: */
    /* Zuerst die Library-Bases, die der Server Prozess bentigt */
    struct Library *dosbase;
    struct Library *intuitionbase;
    struct Library *nipcbase;
    /* Daten fr unsere Entity */
    struct Entity *entity;
    ULONG entitysignal;
    /* Folgendes brauchen wir zum Starten des Servers */
    struct SignalSemaphore startsema;
    struct Task *startprocess;
    struct Process *serverprocess;
    ULONG startservererror;
    ULONG startsignalmask;
};