#include <exec/execbase.h>
#include <dos/rdargs.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>

extern struct ExecBase *SysBase;

char  ArgStr   [] = "FILENAME/A,S=SCHALTER/S";
LONG  ArgArray [2] = { 0,0 };

int main(int argc, char *argv[])
{
   int retcode = RETURN_OK;
   struct RDArgs *rda = NULL;

   if (SysBase->LibNode.lib_Version < 37) return 20;

   if (rda = ReadArgs(ArgStr,ArgArray,rda))
   {
      Printf("Die Parameter lauten: \"%s %s\"\n",
                     ArgArray[0], ArgArray[1] ? "An" : "Aus");
      FreeArgs(rda);
   }
   else
   {  PrintFault(IoErr(),argv[0]);
      retcode = RETURN_FAIL;
   }

   return retcode;
}
