#include <exec/execbase.h>
#include <dos/rdargs.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>

#define  BUFLEN    200
#define  ENVVAR    "TestArgs"

extern struct ExecBase *SysBase;

char  ArgStr   [] = "FILENAME/A,S=SCHALTER/S";
enum              {  filename,    schalter };
LONG  ArgArray [schalter+1] = { 0,0 };

const char ver[] = "$VER: TestArgs 1.0 (08.11.94)";
char    EnvString[BUFLEN] = "";
char    TempBuf  [BUFLEN] = "";

struct  RDArgs  EnvArgs   = {
        {  EnvString, BUFLEN, 0 },
        0, TempBuf, BUFLEN,
        0L,   // Extra Help Text, hier 0
        RDAF_NOALLOC
};

int main(int argc, char *argv[])
{
   int retcode = RETURN_OK;
   struct RDArgs *rda = NULL;

   if (SysBase->LibNode.lib_Version < 37) return 20;

   if (GetVar(ENVVAR,EnvString,BUFLEN,0) > 0)
   {  strcat(EnvString,"\n"); /* LineFeed anhngen */
      /* richtige Lnge eintragen */
      EnvArgs.RDA_Source.CS_Length = strlen(EnvString);
      if (rda = ReadArgs(ArgStr,ArgArray,&EnvArgs))
      {  FreeArgs(rda); }
   }

   if (rda = ReadArgs(ArgStr,ArgArray,rda))
   {
      Printf("Die Parameter lauten: \"%s Schalter %s\"\n",
                     ArgArray[filename],
                     ArgArray[schalter] ? "an" : "aus");
      FreeArgs(rda);
   }
   else
   {  PrintFault(IoErr(),argv[0]);
      retcode = RETURN_FAIL;
   }

   return retcode;
}
